﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Text;

using KeePass.DataExchange;

namespace KeePass1xCS
{
	public static class Program
	{
		public static void Main(string[] args)
		{
			try { MainPriv(args); }
			catch(Exception ex)
			{
				Console.WriteLine(ex.Message);
			}
		}

		private static void MainPriv(string[] args)
		{
			if(args.Length <= 1)
				throw new Exception("Usage: KeePass1xCS.exe FILEPATH PASSWORD");

			string strFile = args[0];
			string strPassword = args[1];

			using(KdbManager mgr = new KdbManager())
			{
				if(mgr.SetMasterKey(strPassword, false, null, IntPtr.Zero, false) !=
					KdbErrorCode.Success)
					throw new Exception("Failed to set master key!");

				KdbErrorCode e = mgr.OpenDatabase(strFile, IntPtr.Zero);
				if(e != KdbErrorCode.Success)
					throw new Exception("Failed to open database (" + e.ToString() + ")!");

				uint cEntries = mgr.EntryCount;
				for(uint u = 0; u < cEntries; ++u)
				{
					KdbEntry ke = mgr.GetEntry(u);

					Console.WriteLine("Title     : " + (ke.Title ?? string.Empty));
					Console.WriteLine("User name : " + (ke.UserName ?? string.Empty));
					Console.WriteLine("Password  : " + (ke.Password ?? string.Empty));
					Console.WriteLine();
				}
			}
		}
	}
}
